﻿@model IEnumerable<WebFBX.Models.ProductosModels>

@{
    Layout = null;
    int i = 0;
    string fechaminima = ViewData["fecha_minima"].ToString();
}

<table id="table_productos" class="table-striped table-bordered tableSection table_consulta cursor_table" cellspacing="0" width="100%" data-role="datatable">
    <thead>
        <tr>

            <th>
                Código
            </th>
            <th>
                Nombre&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
            </th>
            <th>
                Nombre&nbsp;Corto&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
            </th>
            <th>
                Familia&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
            </th>
            <th>
                Un.&nbsp;
            </th>
            <th>
                Obs
            </th>
            <th>
                Pes.Grs
            </th>

            <th>
                Precio
            </th>

            <th title="Indicador stock. Seleccionado:No hay stock. No seleccionado hay stock">
                Agotado
            </th>
            <th>
                Precio Oferta
            </th>
            <th title="Fecha vencimiento oferta">
                Fch.Venc. Oferta
            </th>

            <th title="Indicador oferta. Seleccionado:hay oferta. No seleccionado hay oferta">
                Oferta
            </th>
            <th title="Indicador de página web. Seleccionado:se muestra en la pagina web. No seleccionado no se muestra">
                Ind. P.Web
            </th>
            <th title="Indicador de presentación Seleccionado:se exige la colocar presentación. No seleccionado no muestra presentación">
                Ind. Pres.
            </th>
            <th title="Indicador de presentación Seleccionado:se exige la colocar presentación. No seleccionado no muestra presentación">
                Cabeza/ Esquelon
            </th>
            <th title="Indicador cantidad minima de producto a pedir">
                Cantidad mínima
            </th>
            <th>

            </th>
            <th>

            </th>
        </tr>
    </thead>
    <tbody>

        @foreach (var item in Model)
        {
            i++;
            string fc = item.venceoferta;
        <tr>

            <td>
                @Html.DisplayFor(modelItem => item.codigo)
            </td>
            <td>
                <div style="display:none">@item.nombre</div>
                <input type="text" id="nombre_@i" value="@item.nombre" data-campo="observaciones" data-codigo="@item.codigo" class="form-control form-control-sm color_text_dt_input_select campo" data-numerico="0" />
            </td>
            <td>
                <input type="text" id="nombrecorto_@i" value="@item.nombrecorto" data-campo="nombrecorto" data-codigo="@item.codigo" class="form-control form-control-sm color_text_dt_input_select campo" data-numerico="0" />
            </td>
            <td>
                @Html.Action("ComboboxPartialFamilias", "Familias", new { indice = i, familia = item.familia, producto = item.codigo })
            </td>
            <td>
                <input type="text" id="unidad_@i" value="@item.unidad" class="form-control form-control-sm color_text_dt_input_select campo" data-campo="unidad" data-codigo="@item.codigo" data-numerico="0" />
            </td>
            <td>
                <button type="button" id="abre_obs_@i" class="btn btn-info btn-sm obs" data-observacion="@item.observaciones" data-codigo="@item.codigo" data-fila="@i">
                    <span class="fas fa-folder-open"></span>
                </button>
            </td>
            <td>
                <input type="text" id="pesogrs_@i" value="@item.pesogrs" class="form-control form-control-sm color_text_dt_input_select campo" data-campo="pesogrs" data-codigo="@item.codigo" data-numerico="0" onkeypress="return validateEnteroKeyPress(this,event);" maxlength="5" />
            </td>
            <td>
                <input type="text" id="precio_@i" value="@item.precio.ToString("N0")" class="form-control form-control-sm color_text_dt_input_select text-right campo" data-campo="precio" data-codigo="@item.codigo" data-numerico="1" onblur="this.value = numberFormat_decimal(this.value);" onkeypress="return validateEnteroKeyPress(this,event);" maxlength="9" />
            </td>
            <td class="text-center">
                @if (item.agotado == 0)
                {
                    <input type="checkbox" id="agotado_@i" class="text_dt_input_select agotado" data-fila="@i" data-codigo="@item.codigo" />
                }
                else
                {
                    <input type="checkbox" id="agotado_@i" class="color_text_dt_input_select agotado" data-fila="@i" data-codigo="@item.codigo" checked />
                }
            </td>
            <td>
                <input type="text" id="preciooferta_@i" value="@item.preciooferta.ToString("N2")" class="form-control form-control-sm color_text_dt_input_select text-right" onblur="this.value = numberFormat_decimal(this.value);" onkeypress="return SoloNumerosDecimalesComa(event, '0.0', 9, 2)" /> @*onkeypress="return SoloNumerosDecimales(event, '0.0', 9, 2)"*@

            </td>
            <td class="text-center">
                <input id="venceoferta_@i" type="datetime-local" value="@item.venceoferta" min="@fechaminima"
                       class="form-control form-control-sm color_text_dt_input_select" style="max-width:167px;" />
            </td>
            <td class="text-center">
                @if (item.oferta == 0)
                {
                    <input type="checkbox" id="oferta_@i" class="text_dt_input_select oferta" data-fila="@i" data-codigo="@item.codigo" />
                }
                else
                {
                    <input type="checkbox" id="oferta_@i" class="color_text_dt_input_select oferta" data-fila="@i" data-codigo="@item.codigo" checked />
                }
            </td>
            <td class="text-center">
                @if (item.indpagweb == 0)
                {
                    <input type="checkbox" id="indpagweb_@i" class="text_dt_input_select indpagweb" data-fila="@i" data-codigo="@item.codigo" />
                }
                else
                {
                    <input type="checkbox" id="indpagweb_@i" class="color_text_dt_input_select indpagweb" data-fila="@i" data-codigo="@item.codigo" checked />
                }
            </td>
            <td class="text-center">

                <button type="button" id="abre_presentacion_@i" class="btn btn-info btn-sm abre_presentacion" data-codigo="@item.codigo" data-fila="@i" data-nombre="@item.nombre" data-presentacion="@item.presentacion" title="Agregar Presentación al producto">
                    <span class="fas fa-list-alt"></span>
                </button>
                @*@if (item.presentacion == 0)
        {
            <input type="checkbox" id="presentacion_@i" class="text_dt_input_select indpresentacion indicadorp" data-fila="@i" data-codigo="@item.codigo" data-campo="presentacion" />
        }
        else
        {
            <input type="checkbox" id="presentacion_@i" class="color_text_dt_input_select indpresentacion indicadorp" data-fila="@i" data-codigo="@item.codigo" data-campo="presentacion" checked />
        }*@
            </td>
            <td class="text-center">
                @if (item.indcabezaesquelon == 0)
                {
                    <input type="checkbox" id="indcabezaesquelon_@i" class="text_dt_input_select indcabezaesquelon indicadorp" data-fila="@i" data-codigo="@item.codigo" data-campo="indcabezaesquelon" />
                }
                else
                {
                    <input type="checkbox" id="indcabezaesquelon_@i" class="color_text_dt_input_select indcabezaesquelon indicadorp" data-fila="@i" data-codigo="@item.codigo" data-campo="indcabezaesquelon" checked />
                }
            </td>
            <td>
                <input type="text" id="cantidaddesde_@i" value="@item.cantidaddesde.ToString("N1")" class="form-control form-control-sm color_text_dt_input_select text-right campo" onblur="this.value = numberFormat_decimal(this.value);"  data-campo="cantidaddesde" data-codigo="@item.codigo" data-numerico="1" onkeypress="return SoloNumerosDecimalesComa(event, '0,1', 9, 1)" /> @*onkeypress="return SoloNumerosDecimales(event, '0.0', 9, 2)"*@

            </td>
            <td>
                <button type="button" id="abre_foto_@i" class="btn btn-info btn-sm fotos" data-codigo="@item.codigo" data-fila="@i" data-nombre="@item.nombre" title="Agregar Fotos asociadas al producto">
                    <span class="fas fa-images"></span>
                </button>
            </td>
            <td>
                <button title="Agregar detalle de descripción del producto y videos" type="button" id="abre_detalle_@i" class="btn btn-info btn-sm detalle_descripcion" data-codigo="@item.codigo" data-fila="@i" data-nombre="@item.nombre"
                        data-inddescripcion="@item.inddescripcion" data-titulodescripcion="@item.titulodescripcion" data-descripcion="@item.descripcion" data-codigovideo1="@item.codigovideo1"
                        data-titulovideo="@item.titulovideo" data-codigovideo2="@item.codigovideo2">
                    <span class="fas fa-list"></span>
                </button>
            </td>
        </tr>
        }
    </tbody>
</table>

<script type="text/javascript" class="init">

    $(document).ready(function () {
        table_productos = $('#table_productos').DataTable({
            destroy: true,
            "bInfo": true,
            "bPaginate": true,
            "searching": true,
            "bSort": false,
            //"scrollX": true,
            //"autoWidth": false,
            "scrollX": "100%",
            "scrollXInner": "110%",
            "scrollCollapse": true,
            "autoWidth": false,
            //"columns": [
            //    { "width": "41px" },
            //    { "width": "80px" },
            //    { "width": "60px" },
            //    { "width": "80px" },
            //    { "width": "25px" },
            //    { "width": "27px" },
            //    { "width": "52px" },
            //    { "width": "43px" },
            //    { "width": "32px" },
            //    { "width": "44px" },
            //    { "width": "156px" },
            //    { "width": "36.6px" },
            //    { "width": "35.8px" },
            //    { "width": "10px" },
            //    { "width": "15px" },
            //    { "width": "10px" },
            //],
            "lengthMenu": [[10, 15, 45, 75, 105, 135, 165, 195, 225, 255, 285], [10, 15, 45, 75, 105, 135, 165, 195, 225, 255, 285]],
            "language": {
                "sProcessing": "Procesando...",
                "sLengthMenu": "Mostrar _MENU_ registros",
                "sZeroRecords": "No se encontraron resultados",
                "sEmptyTable": "Ningún dato disponible en esta tabla",
                "sInfo": "Mostrando registros del _START_ al _END_ de un total de _TOTAL_ registros",
                "sInfoEmpty": "Mostrando registros del 0 al 0 de un total de 0 registros",
                "sInfoFiltered": "(filtrado de un total de _MAX_ registros)",
                "sInfoPostFix": "",
                "sSearch": "Buscar:",
                "sUrl": "",
                "sInfoThousands": ",",
                "sLoadingRecords": "Cargando...",
                "oAria": {
                    "sSortAscending": ": Activar para ordenar la columna de manera ascendente",
                    "sSortDescending": ": Activar para ordenar la columna de manera descendente"
                },
                "paginate": {
                    "previous": "Anterior",
                    "next": "Siguiente"
                }
            },
            fixedHeader: {
                header: true,
                footer: true
            },

        });

        $('#table_productos tbody').on('click', '.detalle_descripcion', function (e) {
            //e.preventDefault();
            var codigo = $(this).data('codigo');
            var nombre = $(this).data('nombre').toUpperCase();
            var inddescripcion = $(this).data('inddescripcion').toString();
            var titulodescripcion = $(this).data('titulodescripcion');
            var descripcion = $(this).data('descripcion');
            var codigovideo1= $(this).data('codigovideo1');
            var codigovideo2 = $(this).data('codigovideo2');
            var titulovideo = $(this).data('titulovideo');
            $("#titulodescripcion_edit").val(titulodescripcion);
            $("#descripciondet_edit").val(descripcion);
            $("#titulovideo_edit").val(titulovideo);
            $("#codigovideo1_edit").val(codigovideo1);
            $("#codigovideo2_edit").val(codigovideo2);

            $("#codigo_hidden_prod_detalle").val(codigo);
            
            if (inddescripcion == "1") {
                $("#inddescripcion_edit").prop("checked", true);
                $(".descripcion_edit").removeClass("ocultar");

            } else {
                $(".descripciondet_edit").addClass("ocultar");
                $("#inddescripcion_edit").prop("checked", false);
            }
            $("#codigo_hidden_prod_detalle").val(codigo);
            $("#modal_edit_detalleproducto").modal("show");            
            $("#titulo_detalle").html("EDITAR DETALLE " + nombre);
        });

        $('#table_productos tbody').on('click', '.abre_presentacion', function (e) {
            var codigo = $(this).data('codigo');
            var presentacion = $(this).data('presentacion');
            var fila = $(this).data('fila');
            $("#filapresentacion_hidden").val(fila);
            $('#combobox_codigopresentaciones').val(presentacion);
            listarPresentacionesMostrar(presentacion);
            $("#codigo_hidden_prod_presentacion").val(codigo);
            $("#modal_presentaciones").modal("show");

        });
        $('#table_productos tbody').on('click', '.fotos', function (e) {
            var codigo = $(this).data('codigo');
            var nombre = $(this).data('nombre');

            $("#codigo_producto_foto").val(codigo);
            $("#modal_foto").modal("show");
            recargar_listado_Fotos(codigo);
            $('#id_form_foto').validationEngine('hideAll');
            $("#foto_temp").html("");
            $('#foto_temp + img').remove();
            $("#file_foto").val("");
            $("#titulo_foto_prod").html("ACTUALIZAR FOTOS DE " + nombre);

        });
        $('#table_productos tbody').on('click', '.indicadorp', function (e) {
            //e.preventDefault();
            var codigo = $(this).data('codigo');
            var campo = $(this).data('campo');

            var indicador = 0;
            if ($(this).prop('checked')) {
                indicador = 1;
            }
            var fd = new FormData();
            fd.append("codigo", codigo);
            fd.append("campo", campo);
            fd.append("indicador", indicador);

            $.ajax({
                type: "POST",
                url: '/Administracion/ActualizaIndicador/',
                data: fd,
                contentType: false,
                processData: false,
                DataType: 'json',
                success: function (data) {
                    if (data == "1") {
                        console.log(campo + " actualizada correctamente");
                    }
                    else {
                        $("#modal_error").modal("show");
                        $("#error_modal_msj").html("Error interno:" + data);
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    $("#modal_error").modal("show");
                    $("#error_modal_msj").html("Error de conexion al guardar cliente: " + errorThrown);
                }
            });
        });

        $('#table_productos tbody').on('click', '.agotado', function (e) {
            //e.preventDefault();
            var codigo = $(this).data('codigo');
            var indicador = 0;
            if ($(this).prop('checked')) {
                indicador = 1;
            }
            var fd = new FormData();
            fd.append("codigo", codigo);
            fd.append("indicador", indicador);

            $.ajax({
                type: "POST",
                url: '/Administracion/ActualizaIndStock/',
                data: fd,
                contentType: false,
                processData: false,
                DataType: 'json',
                success: function (data) {
                    if (data == "1") {
                        console.log("Ind Agotado actualizado correctamente")
                    }
                    else {
                        $("#modal_error").modal("show");
                        $("#error_modal_msj").html("Error interno:" + data);
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    $("#modal_error").modal("show");
                    $("#error_modal_msj").html("Error de conexion al guardar cliente: " + errorThrown);
                }
            });
        });


        $('#table_productos tbody').on('click', '.indpagweb', function (e) {
            //e.preventDefault();
            var codigo = $(this).data('codigo');
            var indicador = 0;
            if ($(this).prop('checked')) {
                indicador = 1;
            }          
            var fd = new FormData();
            fd.append("codigo", codigo);
            fd.append("indicador", indicador);

            $.ajax({
                type: "POST",
                url: '/Administracion/ActualizaIndPagWebProducto/',
                data: fd,
                contentType: false,
                processData: false,
                DataType: 'json',
                success: function (data) {
                    if (data == "1") {
                        console.log("indpagweb actualizado correctamente")
                    }
                    else {
                        $("#modal_error").modal("show");
                        $("#error_modal_msj").html("Error interno:" + data);
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    $("#modal_error").modal("show");
                    $("#error_modal_msj").html("Error de conexion al guardar cliente: " + errorThrown);
                }
            });
        });

        $('#table_productos tbody').on('click', '.oferta', function (e) {
            //e.preventDefault();
            var codigo = $(this).data('codigo');
            var fila = $(this).data('fila');
            var preciooferta = table_productos.$("#preciooferta_" + fila).val().replace(/\./g, '').replace(',', '.');
            var venceoferta = table_productos.$("#venceoferta_" + fila).val();


            var checkoferta = $(this).attr('id');
            var oferta = 0;
            if (table_productos.$('#' + checkoferta).prop('checked')) {
                oferta = 1;
            }

            if (oferta == 1) {
                if (preciooferta == "" || preciooferta == 0) {
                    $("#modal_error").modal("show");
                    $("#error_modal_msj").html("Debe indicar precio oferta");
                    e.preventDefault();
                    return false;
                }
                if (venceoferta == "") {
                    $("#modal_error").modal("show");
                    $("#error_modal_msj").html("Debe colocar fecha vencimiento de la oferta");
                    e.preventDefault();
                    return false;
                }
            }

            var fd = new FormData();
            fd.append("codigo", codigo);
            fd.append("preciooferta", preciooferta);
            fd.append("venceoferta", venceoferta);
            fd.append("oferta", oferta);

            $.ajax({
                type: "POST",
                url: '/Administracion/ActualizaOferta/',
                data: fd,
                contentType: false,
                processData: false,
                DataType: 'json',
                success: function (data) {
                    if (data == "1") {
                        console.log("oferta actualizada correctamente");
                    }
                    else {
                        $("#modal_error").modal("show");
                        $("#error_modal_msj").html("Error interno:" + data);
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    $("#modal_error").modal("show");
                    $("#error_modal_msj").html("Error de conexion al guardar cliente: " + errorThrown);
                }
            });
        });

        $('#table_productos tbody').on('change', '.familia', function (e) {
            e.preventDefault();
            var codigo = $(this).data('codigo');
            var idfamilia = $(this).attr('id');
            var valor_cbx = table_productos.$("#" + idfamilia.toString()).val()
            var nombrecbx = table_productos.$("#" + idfamilia.toString() + " option:selected").text();

            var fd = new FormData();
            fd.append("codigo", codigo);
            fd.append("familia", valor_cbx);
            fd.append("nfamilia", nombrecbx);
            $.ajax({
                type: "POST",
                url: '/Administracion/ActualizaFamiliaProducto/',
                data: fd,
                contentType: false,
                processData: false,
                DataType: 'json',
                success: function (data) {
                    if (data == "1") {
                        console.log("familia actualizada correctamente");
                    }
                    else {
                        $("#modal_error").modal("show");
                        $("#error_modal_msj").html("Error interno:" + data);
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    $("#modal_error").modal("show");
                    $("#error_modal_msj").html("Error de conexion al guardar cliente: " + errorThrown);
                }
            });
        });

        $('#table_productos tbody').on('change', '.campo', function (e) {
            e.preventDefault();
            var codigo = $(this).data('codigo');
            var campo = $(this).data('campo');
            var numerico = $(this).data('numerico');
            if ($(this).val() == "") {
                return false;
            }
            if (numerico == "1" || numerico==1) {
                var valorcampo = $(this).val().replace(/\./g, '').replace(',', '.');
            } else {
                var valorcampo = $(this).val();
            }
            var fd = new FormData();
            fd.append("codigo", codigo);
            fd.append("campo", campo);
            fd.append("valorcampo", valorcampo);
            $.ajax({
                type: "POST",
                url: '/Administracion/ActualizaCampoProducto/',
                data: fd,
                contentType: false,
                processData: false,
                DataType: 'json',
                success: function (data) {
                    if (data == "1") {
                        console.log(campo+" actualizada correctamente");
                    }
                    else {
                        $("#modal_error").modal("show");
                        $("#error_modal_msj").html("Error interno:" + data);
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    $("#modal_error").modal("show");
                    $("#error_modal_msj").html("Error de conexion : " + errorThrown);
                }
            });
        });

        $('#table_productos tbody').on('click', '.obs', function (e) {
            e.preventDefault();
            $("#observaciones").val("");
            $("#modal_observacion").modal("show");
            var observacion = $(this).data('observacion');
            var fila = $(this).data('fila');
            $("#fila_hidden").val(fila);

            var codigo = $(this).data('codigo');
            $("#codigo_hidden").val(codigo);
            $("#observaciones").val(observacion);
        });
    });
</script>

